/**
 * @file
 * Scene creation and user callbacks header.
 *
 * @author PCJohn (peciva _AT fit.vutbr.cz)
 */
/* ---------------------------------------------------------------------------
 * Authors:      PCJohn (peciva _AT fit.vutbr.cz)
 * Contributors: Tom "Shamot" Burian (tburian _AT centrum.cz)
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 * ---------------------------------------------------------------------------
 */


#ifndef CMD_PARSER__H
#define CMD_PARSER__H

// #include <stdlib.h>

#ifdef _MSC_VER
float strtof(const char *nptr, char **endptr)  { return float(strtod(nptr, endptr)); }
#endif

/**
 * Functions used in template func getParam to convert strings into other types.
 */
void strtoX(int &r, const char *nptr, char **endptr)
{
  r = strtol(nptr, endptr, 10);
}
void strtoX(float &r, const char *nptr, char **endptr)
{
  r = strtof(nptr, endptr);
}
void strtoX(bool &r, const char *nptr, char **endptr)
{
  int i;
  strtoX(i, nptr, endptr);
  r = (i != 0);
}
/*
void strtoX(char* &r, const char *nptr, char **endptr)
{
  printf("xxx %s",r);
  char * str = r;
  r = str;
}
*/

/** 
 * Template function to parse command line arguments.
 */
template<class Type>
bool getParam(int argc, char **argv, int &position,
              const char *param, Type &result)
{
  if (argc > position && strcmp(argv[position], param) == 0) {
    position++;
    if (argc > position) {
      char *errp;
      Type tmp;
      strtoX(tmp, argv[position], &errp);
      if (*(argv[position]) != '\0' && *errp == '\0') {
        result = tmp;
        position++;
        return true;
      } else {
        printf("Wrong argument \"%s\".", param);
        exit(EXIT_FAILURE);
      }
    } else {
      printf("Missing value for parameter \"%s\".", param);
      exit(EXIT_FAILURE);
    }
  }
  return false;
}

#endif

